#ifndef _KGR_PATCH_BSC1193161_H
#define _KGR_PATCH_BSC1193161_H

#if IS_ENABLED(CONFIG_MAC80211)

#include "bsc1193161_common.h"

int kgr_patch_bsc1193161_init(void);
void kgr_patch_bsc1193161_cleanup(void);

struct sk_buff;
struct ieee80211_rx_data;
struct ieee80211_sub_if_data;

bool kgrp_ieee80211_prepare_and_rx_handle(struct ieee80211_rx_data *rx,
					    struct sk_buff *skb, bool consume);
void kgrp_ieee80211_sta_rx_queued_mgmt(struct ieee80211_sub_if_data *sdata,
				  struct sk_buff *skb);

#define KGR_PATCH_BSC1193161_FUNCS					\
	KGR_PATCH_OBJ(ieee80211_prepare_and_rx_handle,			\
		      kgrp_ieee80211_prepare_and_rx_handle,		\
		      "mac80211"),					\
	KGR_PATCH_OBJ(ieee80211_sta_rx_queued_mgmt,			\
		      kgrp_ieee80211_sta_rx_queued_mgmt, "mac80211"),	\

#else /* !IS_ENABLED(CONFIG_MAC80211) */

static inline int kgr_patch_bsc1193161_init(void) { return 0; }

static inline void kgr_patch_bsc1193161_cleanup(void) {}

#define KGR_PATCH_BSC1193161_FUNCS

#endif /* IS_ENABLED(CONFIG_MAC80211) */
#endif /* _KGR_PATCH_BSC1193161_H */
